# coding: utf-8

"""
    CloudEndure API documentation

    © 2017 CloudEndure All rights reserved  # General Request authentication in CloudEndure's API is done using session cookies. A session cookie is returned upon successful execution of the \"login\" method. This value must then be provided within the request headers of all subsequent API requests.  ## Errors Some errors are not specifically written in every method since they may always return. Those are: 1) 401 (Unauthorized) - for unauthenticated requests. 2) 405 (Method Not Allowed) - for using a method that is not supported (POST instead of GET). 3) 403 (Forbidden) - request is authenticated, but the user is not allowed to access. 4) 422 (Unprocessable Entity) - for invalid input.  ## Formats All strings with date-time format are according to RFC3339.  All strings with \"duration\" format are according to ISO8601. For example, a full day duration can be specified with \"PNNNND\".   # noqa: E501

    OpenAPI spec version: 5
    Contact: https://bit.ly/2T54hSc
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

from cloudendure.cloudendure_api.models.cloud_endure_audit_log_entry import (
    CloudEndureAuditLogEntry,
)  # noqa: F401,E501


class CloudEndureAuditLog:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "items": "list[CloudEndureAuditLogEntry]",
        "has_more_results": "bool",
    }

    attribute_map = {"items": "items", "has_more_results": "hasMoreResults"}

    def __init__(self, items=None, has_more_results=None):  # noqa: E501
        """CloudEndureAuditLog - a model defined in Swagger"""  # noqa: E501
        self._items = None
        self._has_more_results = None
        self.discriminator = None
        if items is not None:
            self.items = items
        if has_more_results is not None:
            self.has_more_results = has_more_results

    @property
    def items(self):
        """Gets the items of this CloudEndureAuditLog.  # noqa: E501


        :return: The items of this CloudEndureAuditLog.  # noqa: E501
        :rtype: list[CloudEndureAuditLogEntry]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this CloudEndureAuditLog.


        :param items: The items of this CloudEndureAuditLog.  # noqa: E501
        :type: list[CloudEndureAuditLogEntry]
        """

        self._items = items

    @property
    def has_more_results(self):
        """Gets the has_more_results of this CloudEndureAuditLog.  # noqa: E501

        AuditLog API will only return max 1500 entries so this is a way to know if there are more.   # noqa: E501

        :return: The has_more_results of this CloudEndureAuditLog.  # noqa: E501
        :rtype: bool
        """
        return self._has_more_results

    @has_more_results.setter
    def has_more_results(self, has_more_results):
        """Sets the has_more_results of this CloudEndureAuditLog.

        AuditLog API will only return max 1500 entries so this is a way to know if there are more.   # noqa: E501

        :param has_more_results: The has_more_results of this CloudEndureAuditLog.  # noqa: E501
        :type: bool
        """

        self._has_more_results = has_more_results

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(CloudEndureAuditLog, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudEndureAuditLog):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
