# coding: utf-8

"""
    CloudEndure API documentation

    © 2017 CloudEndure All rights reserved  # General Request authentication in CloudEndure's API is done using session cookies. A session cookie is returned upon successful execution of the \"login\" method. This value must then be provided within the request headers of all subsequent API requests.  ## Errors Some errors are not specifically written in every method since they may always return. Those are: 1) 401 (Unauthorized) - for unauthenticated requests. 2) 405 (Method Not Allowed) - for using a method that is not supported (POST instead of GET). 3) 403 (Forbidden) - request is authenticated, but the user is not allowed to access. 4) 422 (Unprocessable Entity) - for invalid input.  ## Formats All strings with date-time format are according to RFC3339.  All strings with \"duration\" format are according to ISO8601. For example, a full day duration can be specified with \"PNNNND\".   # noqa: E501

    OpenAPI spec version: 5
    Contact: https://bit.ly/2T54hSc
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

from cloudendure.cloudendure_api.models.cloud_endure_job import (
    CloudEndureJob,
)  # noqa: F401,E501
from cloudendure.cloudendure_api.models.cloud_endure_machine import (
    CloudEndureMachine,
)  # noqa: F401,E501


class CloudEndureMachinesListInvalidIDsAndJob:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "items": "list[CloudEndureMachine]",
        "job": "CloudEndureJob",
        "invalid_machine_i_ds": "list[str]",
    }

    attribute_map = {
        "items": "items",
        "job": "job",
        "invalid_machine_i_ds": "invalidMachineIDs",
    }

    def __init__(self, items=None, job=None, invalid_machine_i_ds=None):  # noqa: E501
        """CloudEndureMachinesListInvalidIDsAndJob - a model defined in Swagger"""  # noqa: E501
        self._items = None
        self._job = None
        self._invalid_machine_i_ds = None
        self.discriminator = None
        if items is not None:
            self.items = items
        if job is not None:
            self.job = job
        if invalid_machine_i_ds is not None:
            self.invalid_machine_i_ds = invalid_machine_i_ds

    @property
    def items(self):
        """Gets the items of this CloudEndureMachinesListInvalidIDsAndJob.  # noqa: E501


        :return: The items of this CloudEndureMachinesListInvalidIDsAndJob.  # noqa: E501
        :rtype: list[CloudEndureMachine]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this CloudEndureMachinesListInvalidIDsAndJob.


        :param items: The items of this CloudEndureMachinesListInvalidIDsAndJob.  # noqa: E501
        :type: list[CloudEndureMachine]
        """

        self._items = items

    @property
    def job(self):
        """Gets the job of this CloudEndureMachinesListInvalidIDsAndJob.  # noqa: E501


        :return: The job of this CloudEndureMachinesListInvalidIDsAndJob.  # noqa: E501
        :rtype: CloudEndureJob
        """
        return self._job

    @job.setter
    def job(self, job):
        """Sets the job of this CloudEndureMachinesListInvalidIDsAndJob.


        :param job: The job of this CloudEndureMachinesListInvalidIDsAndJob.  # noqa: E501
        :type: CloudEndureJob
        """

        self._job = job

    @property
    def invalid_machine_i_ds(self):
        """Gets the invalid_machine_i_ds of this CloudEndureMachinesListInvalidIDsAndJob.  # noqa: E501

        The IDs of the machines for which the operation failed.  # noqa: E501

        :return: The invalid_machine_i_ds of this CloudEndureMachinesListInvalidIDsAndJob.  # noqa: E501
        :rtype: list[str]
        """
        return self._invalid_machine_i_ds

    @invalid_machine_i_ds.setter
    def invalid_machine_i_ds(self, invalid_machine_i_ds):
        """Sets the invalid_machine_i_ds of this CloudEndureMachinesListInvalidIDsAndJob.

        The IDs of the machines for which the operation failed.  # noqa: E501

        :param invalid_machine_i_ds: The invalid_machine_i_ds of this CloudEndureMachinesListInvalidIDsAndJob.  # noqa: E501
        :type: list[str]
        """

        self._invalid_machine_i_ds = invalid_machine_i_ds

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(CloudEndureMachinesListInvalidIDsAndJob, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudEndureMachinesListInvalidIDsAndJob):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
